Index: src/work/marci/experiment/list_graph.h
===================================================================
--- src/work/marci/experiment/list_graph.h	(revision 921)
+++ src/work/marci/experiment/list_graph.h	(revision 986)
@@ -123,6 +123,6 @@
       //ListGraph* G;
       int id;
-      node_item* _tail;
-      node_item* _head;
+      node_item* _source;
+      node_item* _target;
       edge_item* _next_out;
       edge_item* _prev_out;
@@ -150,20 +150,20 @@
     }
 
-    edge_item* _add_edge(node_item* _tail, node_item* _head) {
+    edge_item* _add_edge(node_item* _source, node_item* _target) {
       edge_item* e=new edge_item;
       e->id=edge_id++;
-      e->_tail=_tail;
-      e->_head=_head;
-      
-      e->_prev_out=_tail->_last_out_edge;
-      if (_tail->_last_out_edge) (_tail->_last_out_edge)->_next_out=e;
-      _tail->_last_out_edge=e;
-      if (!_tail->_first_out_edge) _tail->_first_out_edge=e; 
+      e->_source=_source;
+      e->_target=_target;
+      
+      e->_prev_out=_source->_last_out_edge;
+      if (_source->_last_out_edge) (_source->_last_out_edge)->_next_out=e;
+      _source->_last_out_edge=e;
+      if (!_source->_first_out_edge) _source->_first_out_edge=e; 
       e->_next_out=0;
  
-      e->_prev_in=_head->_last_in_edge;
-      if (_head->_last_in_edge) (_head->_last_in_edge)->_next_in=e;
-      _head->_last_in_edge=e;
-      if (!_head->_first_in_edge) { _head->_first_in_edge=e; } 
+      e->_prev_in=_target->_last_in_edge;
+      if (_target->_last_in_edge) (_target->_last_in_edge)->_next_in=e;
+      _target->_last_in_edge=e;
+      if (!_target->_first_in_edge) { _target->_first_in_edge=e; } 
       e->_next_in=0;
 
@@ -185,11 +185,11 @@
     void _delete_edge(edge_item* e) {
       if (e->_next_out) (e->_next_out)->_prev_out=e->_prev_out; else 
-	(e->_tail)->_last_out_edge=e->_prev_out;
+	(e->_source)->_last_out_edge=e->_prev_out;
       if (e->_prev_out) (e->_prev_out)->_next_out=e->_next_out; else 
-	(e->_tail)->_first_out_edge=e->_next_out;
+	(e->_source)->_first_out_edge=e->_next_out;
       if (e->_next_in) (e->_next_in)->_prev_in=e->_prev_in; else 
-	(e->_head)->_last_in_edge=e->_prev_in;
+	(e->_target)->_last_in_edge=e->_prev_in;
       if (e->_prev_in) (e->_prev_in)->_next_in=e->_next_in; else 
-	(e->_head)->_first_in_edge=e->_next_in;
+	(e->_target)->_first_in_edge=e->_next_in;
 
       delete e;
@@ -197,31 +197,31 @@
     }
 
-    void _set_tail(edge_item* e, node_item* _tail) {
+    void _set_source(edge_item* e, node_item* _source) {
       if (e->_next_out) (e->_next_out)->_prev_out=e->_prev_out; else 
-	(e->_tail)->_last_out_edge=e->_prev_out;
+	(e->_source)->_last_out_edge=e->_prev_out;
       if (e->_prev_out) (e->_prev_out)->_next_out=e->_next_out; else 
-	(e->_tail)->_first_out_edge=e->_next_out;
-      
-      e->_tail=_tail;
-      
-      e->_prev_out=_tail->_last_out_edge;
-      if (_tail->_last_out_edge) (_tail->_last_out_edge)->_next_out=e;
-      _tail->_last_out_edge=e;
-      if (!_tail->_first_out_edge) _tail->_first_out_edge=e; 
+	(e->_source)->_first_out_edge=e->_next_out;
+      
+      e->_source=_source;
+      
+      e->_prev_out=_source->_last_out_edge;
+      if (_source->_last_out_edge) (_source->_last_out_edge)->_next_out=e;
+      _source->_last_out_edge=e;
+      if (!_source->_first_out_edge) _source->_first_out_edge=e; 
       e->_next_out=0;
     }
 
-    void _set_head(edge_item* e, node_item* _head) {
+    void _set_target(edge_item* e, node_item* _target) {
       if (e->_next_in) (e->_next_in)->_prev_in=e->_prev_in; else 
-	(e->_head)->_last_in_edge=e->_prev_in;
+	(e->_target)->_last_in_edge=e->_prev_in;
       if (e->_prev_in) (e->_prev_in)->_next_in=e->_next_in; else 
-	(e->_head)->_first_in_edge=e->_next_in;
-      
-      e->_head=_head;
-      
-      e->_prev_in=_head->_last_in_edge;
-      if (_head->_last_in_edge) (_head->_last_in_edge)->_next_in=e;
-      _head->_last_in_edge=e;
-      if (!_head->_first_in_edge) { _head->_first_in_edge=e; } 
+	(e->_target)->_first_in_edge=e->_next_in;
+      
+      e->_target=_target;
+      
+      e->_prev_in=_target->_last_in_edge;
+      if (_target->_last_in_edge) (_target->_last_in_edge)->_next_in=e;
+      _target->_last_in_edge=e;
+      if (!_target->_first_in_edge) { _target->_first_in_edge=e; } 
       e->_next_in=0;
     }
@@ -248,6 +248,6 @@
     //InEdgeIt firstInEdge(const Node v) const { return InEdgeIt(v); }
     //SymEdgeIt firstSymEdge(const Node v) const { return SymEdgeIt(v); }
-    Node tail(Edge e) const { return e.tailNode(); }
-    Node head(Edge e) const { return e.headNode(); }
+    Node source(Edge e) const { return e.sourceNode(); }
+    Node target(Edge e) const { return e.targetNode(); }
 
     Node aNode(const OutEdgeIt& e) const { return e.aNode(); }
@@ -278,6 +278,6 @@
     SymEdgeIt& /*getF*/first(SymEdgeIt& e, Node v) const { 
       e=SymEdgeIt(*this, v); return e; }
-    //void getTail(Node& n, const Edge& e) const { n=tail(e); }
-    //void getHead(Node& n, const Edge& e) const { n=head(e); }
+    //void getSource(Node& n, const Edge& e) const { n=source(e); }
+    //void getTarget(Node& n, const Edge& e) const { n=target(e); }
 
     //void getANode(Node& n, const OutEdgeIt& e) const { n=e.aNode(); }
@@ -346,10 +346,10 @@
     }
 
-    void setTail(Edge e, Node tail) {
-      _set_tail(e.edge, tail.node); 
-    }
-
-    void setHead(Edge e, Node head) {
-      _set_head(e.edge, head.node); 
+    void setSource(Edge e, Node source) {
+      _set_source(e.edge, source.node); 
+    }
+
+    void setTarget(Edge e, Node target) {
+      _set_target(e.edge, target.node); 
     }
 
@@ -360,5 +360,5 @@
     }
     friend std::ostream& operator<<(std::ostream& os, const Edge& i) { 
-      os << "(" << i.edge->_tail->id << "--" << i.edge->id << "->" << i.edge->_head->id << ")"; 
+      os << "(" << i.edge->_source->id << "--" << i.edge->id << "->" << i.edge->_target->id << ")"; 
       return os; 
     }
@@ -427,6 +427,6 @@
       friend bool operator!=(Edge u, Edge v) { return v.edge!=u.edge; } 
     protected:
-      Node tailNode() const { return Node(edge->_tail); }
-      Node headNode() const { return Node(edge->_head); }
+      Node sourceNode() const { return Node(edge->_source); }
+      Node targetNode() const { return Node(edge->_target); }
     public:
       friend std::ostream& operator<<(std::ostream& os, const Edge& i);
@@ -448,5 +448,5 @@
       EdgeIt(edge_item* _e) : Edge(_e) { }
       EdgeIt& operator++() { 
-	node_item* v=edge->_tail;
+	node_item* v=edge->_source;
 	edge=edge->_next_out; 
 	while (v && !edge) { v=v->_next_node; if (v) edge=v->_first_out_edge; }
@@ -468,6 +468,6 @@
       OutEdgeIt& operator++() { edge=edge->_next_out; return *this; }
     protected:
-      Node aNode() const { return Node(edge->_tail); }
-      Node bNode() const { return Node(edge->_head); }
+      Node aNode() const { return Node(edge->_source); }
+      Node bNode() const { return Node(edge->_target); }
     };
     
@@ -485,6 +485,6 @@
       InEdgeIt& operator++() { edge=edge->_next_in; return *this; }
     protected:
-      Node aNode() const { return Node(edge->_head); }
-      Node bNode() const { return Node(edge->_tail); }
+      Node aNode() const { return Node(edge->_target); }
+      Node bNode() const { return Node(edge->_source); }
     };
 
@@ -511,5 +511,5 @@
       SymEdgeIt& operator++() { 
 	if (out_or_in) { 
-	  node_item* v=edge->_tail;
+	  node_item* v=edge->_source;
 	  edge=edge->_next_out; 
 	  if (!edge) { out_or_in=0; edge=v->_first_in_edge; }
@@ -521,7 +521,7 @@
     protected:
       Node aNode() const { 
-	return (out_or_in) ? Node(edge->_tail) : Node(edge->_head); }
+	return (out_or_in) ? Node(edge->_source) : Node(edge->_target); }
       Node bNode() const { 
-	return (out_or_in) ? Node(edge->_head) : Node(edge->_tail); }
+	return (out_or_in) ? Node(edge->_target) : Node(edge->_source); }
     };
 
Index: src/work/marci/graph_concept.h
===================================================================
--- src/work/marci/graph_concept.h	(revision 921)
+++ src/work/marci/graph_concept.h	(revision 986)
@@ -104,8 +104,8 @@
 
 
-    /// Gives back the head node of an edge.
-    Node head(const Edge&) const { return INVALID; }
-    /// Gives back the tail node of an edge.
-    Node tail(const Edge&) const { return INVALID; }
+    /// Gives back the target node of an edge.
+    Node target(const Edge&) const { return INVALID; }
+    /// Gives back the source node of an edge.
+    Node source(const Edge&) const { return INVALID; }
   
     //   Node aNode(SymEdgeIt) const {}
@@ -143,8 +143,8 @@
     /// \brief Add a new edge to the graph.
     ///
-    /// Add a new edge to the graph with tail node \c tail
-    /// and head node \c head.
+    /// Add a new edge to the graph with source node \c source
+    /// and target node \c target.
     /// \return the new edge.
-    Edge addEdge(const Node& tail, const Node& head) { return INVALID; }
+    Edge addEdge(const Node& source, const Node& target) { return INVALID; }
     
     /// \brief Resets the graph.
Index: src/work/marci/iterator_bfs_demo.cc
===================================================================
--- src/work/marci/iterator_bfs_demo.cc	(revision 921)
+++ src/work/marci/iterator_bfs_demo.cc	(revision 986)
@@ -24,5 +24,5 @@
   string operator[](typename Graph::Edge e) const { 
     return 
-      (node_name_map[graph.tail(e)]+"->"+node_name_map[graph.head(e)]);
+      (node_name_map[graph.source(e)]+"->"+node_name_map[graph.target(e)]);
   }
 };
@@ -96,12 +96,12 @@
       if (Graph::Edge(bfs)!=INVALID) {
 	cout << edge_name[bfs] << /*endl*/", " << 
-	  node_name[G.tail(bfs)] << 
-	  (bfs.isANodeExamined() ? ": is examined, " : ": is not examined, ") << 
-	  node_name[G.head(bfs)] << 
+	  node_name[G.source(bfs)] << 
+	  (bfs.isANodeExamined() ? ": is examined, " : ": is not examined, ") << 
+	  node_name[G.target(bfs)] << 
 	  (bfs.isBNodeNewlyReached() ? ": is newly reached." : 
 	   ": is not newly reached.");
       } else { 
 	cout << "invalid" << /*endl*/", " << 
-	  node_name[bfs.tail()] << 
+	  node_name[bfs.source()] << 
 	  (bfs.isANodeExamined() ? ": is examined, " : ": is not examined, ") << 
 	  
@@ -130,12 +130,12 @@
       if (Graph::Edge(dfs)!=INVALID) {
 	cout << edge_name[dfs] << /*endl*/", " << 
-	  node_name[G.tail(dfs)] << 
-	  (dfs.isANodeExamined() ? ": is examined, " : ": is not examined, ") << 
-	  node_name[G.head(dfs)] << 
+	  node_name[G.source(dfs)] << 
+	  (dfs.isANodeExamined() ? ": is examined, " : ": is not examined, ") << 
+	  node_name[G.target(dfs)] << 
 	  (dfs.isBNodeNewlyReached() ? ": is newly reached." : 
 	   ": is not newly reached.");
       } else { 
 	cout << "invalid" << /*endl*/", " << 
-	  node_name[dfs.tail()] << 
+	  node_name[dfs.source()] << 
 	  (dfs.isANodeExamined() ? ": is examined, " : ": is not examined, ") << 
 	  
@@ -172,12 +172,12 @@
       if (GW::Edge(bfs)!=INVALID) {
 	cout << edge_name[GW::Edge(bfs)] << /*endl*/", " << 
-	  node_name[gw.tail(bfs)] << 
-	  (bfs.isANodeExamined() ? ": is examined, " : ": is not examined, ") << 
-	  node_name[gw.head(bfs)] << 
+	  node_name[gw.source(bfs)] << 
+	  (bfs.isANodeExamined() ? ": is examined, " : ": is not examined, ") << 
+	  node_name[gw.target(bfs)] << 
 	  (bfs.isBNodeNewlyReached() ? ": is newly reached." : 
 	   ": is not newly reached.");
       } else { 
 	cout << "invalid" << /*endl*/", " << 
-	  node_name[bfs.tail()] << 
+	  node_name[bfs.source()] << 
 	  (bfs.isANodeExamined() ? ": is examined, " : ": is not examined, ") << 
 	  
@@ -206,12 +206,12 @@
       if (GW::Edge(dfs)!=INVALID) {
 	cout << edge_name[GW::Edge(dfs)] << /*endl*/", " << 
-	  node_name[gw.tail(dfs)] << 
-	  (dfs.isANodeExamined() ? ": is examined, " : ": is not examined, ") << 
-	  node_name[gw.head(dfs)] << 
+	  node_name[gw.source(dfs)] << 
+	  (dfs.isANodeExamined() ? ": is examined, " : ": is not examined, ") << 
+	  node_name[gw.target(dfs)] << 
 	  (dfs.isBNodeNewlyReached() ? ": is newly reached." : 
 	   ": is not newly reached.");
       } else { 
 	cout << "invalid" << /*endl*/", " << 
-	  node_name[dfs.tail()] << 
+	  node_name[dfs.source()] << 
 	  (dfs.isANodeExamined() ? ": is examined, " : ": is not examined, ") << 
 	  
@@ -311,5 +311,5 @@
     cout << "bfs and dfs iterator demo on the bidirected graph" << endl;
 //     for(GW::EdgeIt e(gw); e!=INVALID; ++e) {
-//       cout << node_name[gw.tail(e)] << "->" << node_name[gw.head(e)] << " ";
+//       cout << node_name[gw.source(e)] << "->" << node_name[gw.target(e)] << " ";
 //     } 
     for(GW::NodeIt n(gw); n!=INVALID; ++n) { 
@@ -335,12 +335,12 @@
       if (GW::Edge(bfs)!=INVALID) {
 	cout << edge_name[GW::Edge(bfs)] << /*endl*/", " << 
-	  node_name[gw.tail(bfs)] << 
-	  (bfs.isANodeExamined() ? ": is examined, " : ": is not examined, ") << 
-	  node_name[gw.head(bfs)] << 
+	  node_name[gw.source(bfs)] << 
+	  (bfs.isANodeExamined() ? ": is examined, " : ": is not examined, ") << 
+	  node_name[gw.target(bfs)] << 
 	  (bfs.isBNodeNewlyReached() ? ": is newly reached." : 
 	   ": is not newly reached.");
       } else { 
 	cout << "invalid" << /*endl*/", " << 
-	  node_name[bfs.tail()] << 
+	  node_name[bfs.source()] << 
 	  (bfs.isANodeExamined() ? ": is examined, " : ": is not examined, ") << 
 	  
@@ -369,12 +369,12 @@
       if (GW::Edge(dfs)!=INVALID) {
 	cout << edge_name[GW::Edge(dfs)] << /*endl*/", " << 
-	  node_name[gw.tail(dfs)] << 
-	  (dfs.isANodeExamined() ? ": is examined, " : ": is not examined, ") << 
-	  node_name[gw.head(dfs)] << 
+	  node_name[gw.source(dfs)] << 
+	  (dfs.isANodeExamined() ? ": is examined, " : ": is not examined, ") << 
+	  node_name[gw.target(dfs)] << 
 	  (dfs.isBNodeNewlyReached() ? ": is newly reached." : 
 	   ": is not newly reached.");
       } else { 
 	cout << "invalid" << /*endl*/", " << 
-	  node_name[dfs.tail()] << 
+	  node_name[dfs.source()] << 
 	  (dfs.isANodeExamined() ? ": is examined, " : ": is not examined, ") << 
 	  
Index: src/work/marci/leda/bipartite_matching_comparison.cc
===================================================================
--- src/work/marci/leda/bipartite_matching_comparison.cc	(revision 921)
+++ src/work/marci/leda/bipartite_matching_comparison.cc	(revision 986)
@@ -130,5 +130,5 @@
 
   FOR_EACH_LOC(BGW::EdgeIt, e, bgw) 
-    hg.addEdge(b_s_nodes[bgw.tail(e)], b_t_nodes[bgw.head(e)]);
+    hg.addEdge(b_s_nodes[bgw.source(e)], b_t_nodes[bgw.target(e)]);
 
   ConstMap<SageGraph::Edge, int> cm(1);
Index: src/work/marci/leda/leda_graph_wrapper.h
===================================================================
--- src/work/marci/leda/leda_graph_wrapper.h	(revision 921)
+++ src/work/marci/leda/leda_graph_wrapper.h	(revision 986)
@@ -214,19 +214,19 @@
 //     }
 
-    ///Gives back the head node of an edge.
-    Node head(Edge e) const { 
+    ///Gives back the target node of an edge.
+    Node target(Edge e) const { 
       return Node(l_graph->target(e.l_e)); 
     }
-    ///Gives back the tail node of an edge.
-    Node tail(Edge e) const { 
+    ///Gives back the source node of an edge.
+    Node source(Edge e) const { 
       return Node(l_graph->source(e.l_e)); 
     }
   
-    Node aNode(InEdgeIt e) const { return head(e); }
-    Node aNode(OutEdgeIt e) const { return tail(e); }
+    Node aNode(InEdgeIt e) const { return target(e); }
+    Node aNode(OutEdgeIt e) const { return source(e); }
     //   Node aNode(SymEdgeIt) const {}
 
-    Node bNode(InEdgeIt e) const { return tail(e); }
-    Node bNode(OutEdgeIt e) const { return head(e); }
+    Node bNode(InEdgeIt e) const { return source(e); }
+    Node bNode(OutEdgeIt e) const { return target(e); }
     //   Node bNode(SymEdgeIt) const {}
 
@@ -245,6 +245,6 @@
   
     Node addNode() const { return Node(l_graph->new_node()); }
-    Edge addEdge(Node tail, Node head) const { 
-      return Edge(l_graph->new_edge(tail.l_n, head.l_n));
+    Edge addEdge(Node source, Node target) const { 
+      return Edge(l_graph->new_edge(source.l_n, target.l_n));
     }
     
Index: src/work/marci/leda/max_bipartite_matching_demo.cc
===================================================================
--- src/work/marci/leda/max_bipartite_matching_demo.cc	(revision 921)
+++ src/work/marci/leda/max_bipartite_matching_demo.cc	(revision 986)
@@ -104,8 +104,8 @@
 //     cout << "out edges: ";
 //     for(OutEdgeIt e=G.first<OutEdgeIt>(n); G.valid(e); G.next(e)) 
-//       cout << G.id(G.tail(e)) << "->" << G.id(G.head(e)) << " ";
+//       cout << G.id(G.source(e)) << "->" << G.id(G.target(e)) << " ";
 //     cout << "in edges: ";
 //     for(InEdgeIt e=G.first<InEdgeIt>(n); G.valid(e); G.next(e)) 
-//       cout << G.id(G.tail(e)) << "->" << G.id(G.head(e)) << " ";
+//       cout << G.id(G.source(e)) << "->" << G.id(G.target(e)) << " ";
 //     cout << endl;
 //   }
@@ -124,5 +124,5 @@
     while (max_flow_test.augmentOnShortestPath()) { 
 //       for(EdgeIt e=G.first<EdgeIt>(); G.valid(e); G.next(e))  
-// 	std::cout << G.id(G.tail(e)) << "-" << flow.get(e) << "->" << G.id(G.head(e)) << " ";
+// 	std::cout << G.id(G.source(e)) << "-" << flow.get(e) << "->" << G.id(G.target(e)) << " ";
 //       std::cout<<std::endl;
       ++i; 
@@ -132,10 +132,10 @@
 //     for(EdgeIt e=G.first<EdgeIt>(); G.valid(e); G.next(e))  
 //       if (flow.get(e))
-// 	std::cout << G.id(G.tail(e)) << "-" << flow.get(e) << "->" << G.id(G.head(e)) << " ";
+// 	std::cout << G.id(G.source(e)) << "-" << flow.get(e) << "->" << G.id(G.target(e)) << " ";
 //     std::cout<<std::endl;
 //     std::cout << "edges which are not in this maximum matching: "<< std::endl;
 //     for(EdgeIt e=G.first<EdgeIt>(); G.valid(e); G.next(e))  
 //       if (!flow.get(e))
-// 	std::cout << G.id(G.tail(e)) << "-" << flow.get(e) << "->" << G.id(G.head(e)) << " ";
+// 	std::cout << G.id(G.source(e)) << "-" << flow.get(e) << "->" << G.id(G.target(e)) << " ";
 //     std::cout<<std::endl;
     
@@ -157,5 +157,5 @@
 //     while (max_flow_test.augmentOnBlockingFlow2()) { 
 // //       for(EdgeIt e=G.first<EdgeIt>(); G.valid(e); G.next(e))  
-// // 	std::cout << G.id(G.tail(e)) << "-" << flow.get(e) << "->" << G.id(G.head(e)) << " ";
+// // 	std::cout << G.id(G.source(e)) << "-" << flow.get(e) << "->" << G.id(G.target(e)) << " ";
 // //       std::cout<<std::endl;
 //       ++i; 
@@ -165,10 +165,10 @@
 // //     for(EdgeIt e=G.first<EdgeIt>(); G.valid(e); G.next(e))  
 // //       if (flow.get(e))
-// // 	std::cout << G.id(G.tail(e)) << "-" << flow.get(e) << "->" << G.id(G.head(e)) << " ";
+// // 	std::cout << G.id(G.source(e)) << "-" << flow.get(e) << "->" << G.id(G.target(e)) << " ";
 // //     std::cout<<std::endl;
 // //     std::cout << "edges which are not in this maximum matching: "<< std::endl;
 // //     for(EdgeIt e=G.first<EdgeIt>(); G.valid(e); G.next(e))  
 // //       if (!flow.get(e))
-// // 	std::cout << G.id(G.tail(e)) << "-" << flow.get(e) << "->" << G.id(G.head(e)) << " ";
+// // 	std::cout << G.id(G.source(e)) << "-" << flow.get(e) << "->" << G.id(G.target(e)) << " ";
 // //     std::cout<<std::endl;
     
@@ -199,10 +199,10 @@
 //     for(EdgeIt e=G.first<EdgeIt>(); G.valid(e); G.next(e))  
 //       if (flow.get(e))
-// 	std::cout << G.id(G.tail(e)) << "-" << flow.get(e) << "->" << G.id(G.head(e)) << " ";
+// 	std::cout << G.id(G.source(e)) << "-" << flow.get(e) << "->" << G.id(G.target(e)) << " ";
 //     std::cout<<std::endl;
 //     std::cout << "edges which are not in this maximum matching: "<< std::endl;
 //     for(EdgeIt e=G.first<EdgeIt>(); G.valid(e); G.next(e))  
 //       if (!flow.get(e))
-// 	std::cout << G.id(G.tail(e)) << "-" << flow.get(e) << "->" << G.id(G.head(e)) << " ";
+// 	std::cout << G.id(G.source(e)) << "-" << flow.get(e) << "->" << G.id(G.target(e)) << " ";
 //     std::cout<<std::endl;
     
Index: src/work/marci/leda_bfs_dfs.cc
===================================================================
--- src/work/marci/leda_bfs_dfs.cc	(revision 921)
+++ src/work/marci/leda_bfs_dfs.cc	(revision 986)
@@ -26,5 +26,5 @@
   string get(typename Graph::Edge e) const { 
     return 
-      (node_name_map.get(graph.tail(e))+"->"+node_name_map.get(graph.head(e)));
+      (node_name_map.get(graph.source(e))+"->"+node_name_map.get(graph.target(e)));
   }
 };
Index: src/work/marci/leda_graph_demo.cc
===================================================================
--- src/work/marci/leda_graph_demo.cc	(revision 921)
+++ src/work/marci/leda_graph_demo.cc	(revision 986)
@@ -39,8 +39,8 @@
 //     cout << "out edges: ";
 //     for(OutEdgeIt e=G.first<OutEdgeIt>(n); G.valid(e); G.next(e)) 
-//       cout << G.id(G.tail(e)) << "-" << cap.get(e) << "->" << G.id(G.head(e)) << " ";
+//       cout << G.id(G.source(e)) << "-" << cap.get(e) << "->" << G.id(G.target(e)) << " ";
 //     cout << "in edges: ";
 //     for(InEdgeIt e=G.first<InEdgeIt>(n); G.valid(e); G.next(e)) 
-//       cout << G.id(G.tail(e)) << "-" << cap.get(e) << "->" << G.id(G.head(e)) << " ";
+//       cout << G.id(G.source(e)) << "-" << cap.get(e) << "->" << G.id(G.target(e)) << " ";
 //     cout << endl;
 //   }
@@ -65,5 +65,5 @@
     while (max_flow_test.augmentOnShortestPath()) { 
 //     for(EdgeIt e=G.template first<EdgeIt>(); e.valid(); ++e) { 
-//       std::cout<<"("<<G.tail(e)<< "-"<<flow.get(e)<<"->"<<G.head(e)<<") ";
+//       std::cout<<"("<<G.source(e)<< "-"<<flow.get(e)<<"->"<<G.target(e)<<") ";
 //     }
 //     std::cout<<std::endl;
@@ -73,5 +73,5 @@
 //   std::cout << "maximum flow: "<< std::endl;
 //   for(EdgeIt e=G.first<EdgeIt>(); e.valid(); ++e) { 
-//     std::cout<<"("<<G.tail(e)<< "-"<<flow.get(e)<<"->"<<G.head(e)<<") ";
+//     std::cout<<"("<<G.source(e)<< "-"<<flow.get(e)<<"->"<<G.target(e)<<") ";
 //   }
 //   std::cout<<std::endl;
Index: src/work/marci/lp/max_flow_by_lp.cc
===================================================================
--- src/work/marci/lp/max_flow_by_lp.cc	(revision 921)
+++ src/work/marci/lp/max_flow_by_lp.cc	(revision 986)
@@ -64,7 +64,7 @@
 
     FOR_EACH_LOC(Graph::EdgeIt, e, g) {
-      if (cut[g.tail(e)] && !cut[g.head(e)] && !flow[e]==cap[e]) 
-	std::cout << "Slackness does not hold!" << std::endl;
-      if (!cut[g.tail(e)] && cut[g.head(e)] && flow[e]>0) 
+      if (cut[g.source(e)] && !cut[g.target(e)] && !flow[e]==cap[e]) 
+	std::cout << "Slackness does not hold!" << std::endl;
+      if (!cut[g.source(e)] && cut[g.target(e)] && flow[e]>0) 
 	std::cout << "Slackness does not hold!" << std::endl;
     }
@@ -80,7 +80,7 @@
 
 //     FOR_EACH_LOC(Graph::EdgeIt, e, g) {
-//       if (cut[g.tail(e)] && !cut[g.head(e)] && !flow[e]==cap[e]) 
-// 	std::cout << "Slackness does not hold!" << std::endl;
-//       if (!cut[g.tail(e)] && cut[g.head(e)] && flow[e]>0) 
+//       if (cut[g.source(e)] && !cut[g.target(e)] && !flow[e]==cap[e]) 
+// 	std::cout << "Slackness does not hold!" << std::endl;
+//       if (!cut[g.source(e)] && cut[g.target(e)] && flow[e]>0) 
 // 	std::cout << "Slackness does not hold!" << std::endl;
 //     }
@@ -107,7 +107,7 @@
 
     FOR_EACH_LOC(Graph::EdgeIt, e, g) {
-      if (cut[g.tail(e)] && !cut[g.head(e)] && !flow[e]==cap[e]) 
-	std::cout << "Slackness does not hold!" << std::endl;
-      if (!cut[g.tail(e)] && cut[g.head(e)] && flow[e]>0) 
+      if (cut[g.source(e)] && !cut[g.target(e)] && !flow[e]==cap[e]) 
+	std::cout << "Slackness does not hold!" << std::endl;
+      if (!cut[g.source(e)] && cut[g.target(e)] && flow[e]>0) 
 	std::cout << "Slackness does not hold!" << std::endl;
     }
@@ -136,7 +136,7 @@
 
     FOR_EACH_LOC(Graph::EdgeIt, e, g) {
-      if (cut[g.tail(e)] && !cut[g.head(e)] && !flow[e]==cap[e]) 
-	std::cout << "Slackness does not hold!" << std::endl;
-      if (!cut[g.tail(e)] && cut[g.head(e)] && flow[e]>0) 
+      if (cut[g.source(e)] && !cut[g.target(e)] && !flow[e]==cap[e]) 
+	std::cout << "Slackness does not hold!" << std::endl;
+      if (!cut[g.source(e)] && cut[g.target(e)] && flow[e]>0) 
 	std::cout << "Slackness does not hold!" << std::endl;
     }
@@ -154,7 +154,7 @@
 
 //     FOR_EACH_LOC(Graph::EdgeIt, e, g) {
-//       if (cut[g.tail(e)] && !cut[g.head(e)] && !flow[e]==cap[e]) 
-// 	std::cout << "Slackness does not hold!" << std::endl;
-//       if (!cut[g.tail(e)] && cut[g.head(e)] && flow[e]>0) 
+//       if (cut[g.source(e)] && !cut[g.target(e)] && !flow[e]==cap[e]) 
+// 	std::cout << "Slackness does not hold!" << std::endl;
+//       if (!cut[g.source(e)] && cut[g.target(e)] && flow[e]>0) 
 // 	std::cout << "Slackness does not hold!" << std::endl;
 //     }
@@ -172,7 +172,7 @@
 
 //     FOR_EACH_LOC(Graph::EdgeIt, e, g) {
-//       if (cut[g.tail(e)] && !cut[g.head(e)] && !flow[e]==cap[e]) 
-// 	std::cout << "Slackness does not hold!" << std::endl;
-//       if (!cut[g.tail(e)] && cut[g.head(e)] && flow[e]>0) 
+//       if (cut[g.source(e)] && !cut[g.target(e)] && !flow[e]==cap[e]) 
+// 	std::cout << "Slackness does not hold!" << std::endl;
+//       if (!cut[g.source(e)] && cut[g.target(e)] && flow[e]>0) 
 // 	std::cout << "Slackness does not hold!" << std::endl;
 //     }
Index: src/work/marci/max_flow_demo.cc
===================================================================
--- src/work/marci/max_flow_demo.cc	(revision 921)
+++ src/work/marci/max_flow_demo.cc	(revision 986)
@@ -48,7 +48,7 @@
 
     for(Graph::EdgeIt e(g); e!=INVALID; ++e) {
-      if (cut[g.tail(e)] && !cut[g.head(e)] && !flow[e]==cap[e]) 
+      if (cut[g.source(e)] && !cut[g.target(e)] && !flow[e]==cap[e]) 
 	std::cout << "Slackness does not hold!" << std::endl;
-      if (!cut[g.tail(e)] && cut[g.head(e)] && flow[e]>0) 
+      if (!cut[g.source(e)] && cut[g.target(e)] && flow[e]>0) 
 	std::cout << "Slackness does not hold!" << std::endl;
     }
@@ -64,7 +64,7 @@
 
     for(Graph::EdgeIt e(g); e!=INVALID; ++e) {
-      if (cut[g.tail(e)] && !cut[g.head(e)] && !flow[e]==cap[e]) 
+      if (cut[g.source(e)] && !cut[g.target(e)] && !flow[e]==cap[e]) 
 	std::cout << "Slackness does not hold!" << std::endl;
-      if (!cut[g.tail(e)] && cut[g.head(e)] && flow[e]>0) 
+      if (!cut[g.source(e)] && cut[g.target(e)] && flow[e]>0) 
 	std::cout << "Slackness does not hold!" << std::endl;
     }
@@ -91,7 +91,7 @@
 
     for(Graph::EdgeIt e(g); e!=INVALID; ++e) {
-      if (cut[g.tail(e)] && !cut[g.head(e)] && !flow[e]==cap[e]) 
+      if (cut[g.source(e)] && !cut[g.target(e)] && !flow[e]==cap[e]) 
 	std::cout << "Slackness does not hold!" << std::endl;
-      if (!cut[g.tail(e)] && cut[g.head(e)] && flow[e]>0) 
+      if (!cut[g.source(e)] && cut[g.target(e)] && flow[e]>0) 
 	std::cout << "Slackness does not hold!" << std::endl;
     }
@@ -109,7 +109,7 @@
 
     for(Graph::EdgeIt e(g); e!=INVALID; ++e) {
-      if (cut[g.tail(e)] && !cut[g.head(e)] && !flow[e]==cap[e]) 
+      if (cut[g.source(e)] && !cut[g.target(e)] && !flow[e]==cap[e]) 
 	std::cout << "Slackness does not hold!" << std::endl;
-      if (!cut[g.tail(e)] && cut[g.head(e)] && flow[e]>0) 
+      if (!cut[g.source(e)] && cut[g.target(e)] && flow[e]>0) 
 	std::cout << "Slackness does not hold!" << std::endl;
     }
@@ -127,7 +127,7 @@
 
     for(Graph::EdgeIt e(g); e!=INVALID; ++e) {
-      if (cut[g.tail(e)] && !cut[g.head(e)] && !flow[e]==cap[e]) 
+      if (cut[g.source(e)] && !cut[g.target(e)] && !flow[e]==cap[e]) 
 	std::cout << "Slackness does not hold!" << std::endl;
-      if (!cut[g.tail(e)] && cut[g.head(e)] && flow[e]>0) 
+      if (!cut[g.source(e)] && cut[g.target(e)] && flow[e]>0) 
 	std::cout << "Slackness does not hold!" << std::endl;
     }
@@ -145,7 +145,7 @@
 
     for(Graph::EdgeIt e(g); e!=INVALID; ++e) {
-      if (cut[g.tail(e)] && !cut[g.head(e)] && !flow[e]==cap[e]) 
+      if (cut[g.source(e)] && !cut[g.target(e)] && !flow[e]==cap[e]) 
 	std::cout << "Slackness does not hold!" << std::endl;
-      if (!cut[g.tail(e)] && cut[g.head(e)] && flow[e]>0) 
+      if (!cut[g.source(e)] && cut[g.target(e)] && flow[e]>0) 
 	std::cout << "Slackness does not hold!" << std::endl;
     }
